#ifndef __FEATURE_POINT_H__
#define __FEATURE_POINT_H__

#include "Vec.h"
#include "Mat.h"
#include "Image.h"
#include "SmoothingFilter.h"
#include "Gauss.h"

extern double DET_EPS;

class FeaturePoint{	
  public:
   VecC point;//ɸ
   Mat cov;   //ʬ
   Mat Axis;  //ɸΰĹ¤û(гǤ˳Ǽ)
   Mat T;     //ɸΰη
   bool be;   //ͭħݤ

  private:
   double selfSSD(const Image &im, int x, int y,
                  const Gauss &gauss) const ;
   double partial_differential(const Image &im,
                               const SmoothingFilter &mask,
                               const VecC&p);
  public:
   FeaturePoint();//:point(3),cov(2,2),Axis(2,2),T(2,2)
   ~FeaturePoint() {};
   bool calc_parameter();
   bool calc_cov_by_residual(const Image &im, const Gauss& gauss);		
   bool calc_cov_by_derivative(const Image &im,
                               const SmoothingFilter &mask_u,
                               const SmoothingFilter &mask_v,
                               int template_size);
};

#endif
