#ifndef __TRIVECTOR_H__
#define __TRIVECTOR_H__

#include <iostream>

using std::cerr;
using std::endl;

#include "FeaturePoint.h"
#include "Gauss.h"
#include "Image.h"

class TriVector{
  private:
   double *profile;
   double *STRstart;
   double *STRend;
   int dim,radius_div, angle_div;	
   bool be;
	
	
   //ץե٥ȥʬ
   bool make_profile_vector(const Image & im,
                            const FeaturePoint &start,
                            const FeaturePoint& end,
                            const Gauss & gauss);
	  
   //ɸΰ
   bool make_standard_region(double *STReg, const Image & im,
                             const FeaturePoint &pt, const Mat & rotation,
                             int radius_scale,const Gauss &gauss);
   //ȥ٥ȥƤǤʿѤ
   void calc_Rotation(VecC & direction, Mat &Rotation);
  public:
   bool is_true()const {return be;}
   TriVector();
   TriVector(const TriVector &tv);
   ~TriVector();
   TriVector& operator=(const TriVector &tv);
	
   //ȥ٥ȥκ
   //im              :ϲ
   //start,end       :ħ()
   //dim             :ץե٥ȥʬǿ
   //radius_division :ɸΰ٥ȥȾʬ
   //angle_division  :ɸΰ٥ȥγʬ
   //d_min, d_max    :2֤εΥ(Ǿ)
   //gauss           :ŤߤΥơ֥
   bool make_tri_vector(const Image & im,
                        const Gauss &gauss,
                        const FeaturePoint &start,const FeaturePoint &end,
                        int dimension,double d_min, double d_max,
                        int radius_division, int radius_scale, 
                        int angle_division);

   bool normalize_SSD();
   bool normalize_CC();
	
   //SSDˤٷ׻
   //tv1,tv2  : ٤η׻оݤȤʤ뻰ȥ٥ȥ
   //pv_th    : ξץե٥ȥγǤкФ []
   //str_th   : ξɸΰ٥ȥγǤкФ []
   static double similarity_SSD(const TriVector &tv1, const TriVector &tv2,
                                double pv_th, double str_th,
                                double pv_weight, double str_weight);
   void show() const{
      for(int i=0; i<dim;i++)
         cerr<<"profile["<<i<<"] = "<<profile[i]<<endl;
      for(int i=0; i<radius_div*angle_div;i++){
         cerr<<"str_s["<<i<<"] = "<<STRstart[i]<<endl;
      }
      for(int i=0; i<radius_div*angle_div;i++){
         cerr<<"str_e["<<i<<"] = "<<STRend[i]<<endl;
      }
   }

};

#endif
