#ifndef __TRIANGLEVECTOR_H__
#define __TRIANGLEVECTOR_H__

#include <iostream>
using std::cerr;
using std::endl;

#include "Image.h"
#include "FeaturePoint.h"
#include "Gauss.h"

class TriangleVector{
   double *triangle;
   int dim;
//   bool be;
  
  public:
   bool be;
   TriangleVector(const Image &img, const Gauss &gauss, int length, 
                  const FeaturePoint &pt1,
                  const FeaturePoint &pt2,
                  const FeaturePoint &pt3);
   ~TriangleVector();
   static double similarity_SSD(const TriangleVector &tr1,
                                const TriangleVector &tr2,
                                double triangle_th, double triangle_weight);
   int size() const {return dim;}
   void show() const
      {
         for(int i=0; i<dim; i++){
            cerr << "triangle["<<i<<"] = " << triangle[i] << endl;
         }
      }
};

#endif
