#ifndef	_HARRIS_H_
#define	_HARRIS_H_

class	Image;

// ǥե

#include "HarrisCommonDefs.h"

int	Harris(const Image &InImg,
	       int **up0, int **vp0, 
               double **value,
               int *cnr_num,
	       int Ns = Mask_Size,
	       double sigma = Sigma,
	       double rk = K_value,
	       double s = Rel_r,
	       int max_corner = Max_Corner,
	       double min_dist = Min_Distance);

int	ImpHarris(const Image &InImg,
                  int **up0, int **vp0, 
                  double **value,
                  int *cnr_num,
                  int  Ns = Mask_Size,
                  double sigma = Sigma,
                  double rk = K_value,
                  double s = Rel_r,
                  int max_corner = Max_Corner,
                  double min_dist = Min_Distance);

#endif	// _HARRIS_H_
