#ifndef __FUNDAMENTAL_ESTIMATION_H__
#define __FUNDAMENTAL_ESTIMATION_H__

#include <list>
using std::vector;

#include "fundamental.h"
#include "CrsPoint.h"

#define MAXITR  300     // Maximum iteration for RANSAC
#define MAXITRN 300     // Maximum iteration for renormalization
#define DEGN    1       // degree for renormalization

/////////////////////////////////////////////////////////////////////
//Զ«ɤȽ̤ʤΤб
// 
// crsp_list     бǡ( & )
// img_width     β
// img_height    ν
// focal_length  Υ
// dist          Ĥߵ
//
//  true     false
bool
fundamental_estimation(list<CORRES_POINT> &crsp_list,
                       int img_width, int img_height, double focal_length,
                       double dist);

#endif
